package com.alterdekim.services;

import com.alterdekim.Connection;
import com.alterdekim.Protocol;
import com.alterdekim.hearthhack.util.BattleNetPacket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ChannelService extends Service {

    private static final Logger log = LoggerFactory.getLogger(ChannelService.class);

    public ChannelService(String export_name) {
        super(export_name);
    }

    @Override
    public void process(BattleNetPacket packet, Connection conn) throws Exception {
        switch (packet.getHeader().getMethodId()) {
            case 1:
                Protocol.CISubscribeRequest ciSubscribeRequest = Protocol.CISubscribeRequest.parseFrom(packet.getBody());
                Protocol.CISubscribeResponse ciSubscribeResponse = Protocol.CISubscribeResponse.getDefaultInstance();
                Protocol.Header header = Protocol.Header.newBuilder(packet.getHeader())
                                .setServiceId(254)
                                .setSize(ciSubscribeResponse.getSerializedSize())
                                .build();
                conn.send(new BattleNetPacket(header, ciSubscribeResponse.toByteArray()));
                break;
            default:
                log.error("Can't process weird ChannelService method: " + packet.getHeader().getMethodId());
                break;
        }
    }
}
