package com.alterdekim.services;

import com.alterdekim.Connection;
import com.alterdekim.Protocol;
import com.alterdekim.hearthhack.util.BattleNetPacket;
import com.alterdekim.hearthhack.util.Util;
import com.google.protobuf.ByteString;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ResourcesService extends Service {

    private static final Logger log = LoggerFactory.getLogger(ResourcesService.class);

    public ResourcesService(String export_name) {
        super(export_name);
    }

    @Override
    public void process(BattleNetPacket packet, Connection conn) throws Exception {
        switch (packet.getHeader().getMethodId()) {
            case 1:
               // Protocol.ContentHandleRequest contentHandleRequest = Protocol.ContentHandleRequest.parseFrom(packet.getBody());
                Protocol.ContentHandle contentHandle = Protocol.ContentHandle.newBuilder()
                        .setRegion(17749)
                        .setUsage(1885762681)
                        .setHash(ByteString.copyFrom(Util.hexStringToByteArray("5b2f9b39434a1c4e3f970a76c1e97a8548c95da2ad52a6d37cf9d793dedd887d")))
                        .build();

                Protocol.Header header = Protocol.Header.newBuilder()
                        .setServiceId(254)
                        .setSize(contentHandle.getSerializedSize())
                        .setStatus(0)
                        .setToken(packet.getHeader().getToken())
                        .setObjectId(0)
                        .build();
                conn.send(new BattleNetPacket(header, contentHandle.toByteArray()));
                break;
            default:
                log.error("Can't process weird ResourcesService method: " + packet.getHeader().getMethodId());
                break;
        }
    }
}
